<!DOCTYPE html>
<html>
<head>
	<title>Search Page</title>
	<style>
		body {
			font-family: Arial, sans-serif;
			background-color: #f2f2f2;
		}
		.container {
			max-width: 800px;
			margin: auto;
			padding: 20px;
			background-color: #fff;
			box-shadow: 0 0 10px rgba(0,0,0,0.2);
		}
		h1 {
			text-align: center;
			margin-bottom: 30px;
		}
		form {
			display: flex;
			flex-wrap: wrap;
			justify-content: space-between;
			align-items: center;
		}
		label {
			display: block;
			margin-bottom: 10px;
			font-weight: bold;
		}
		input[type="text"], select {
			padding: 10px;
			border: none;
			border-radius: 5px;
			background-color: #f2f2f2;
			margin-bottom: 20px;
			width: 100%;
			max-width: 400px;
		}
		input[type="submit"] {
			background-color: #4CAF50;
			color: #fff;
			border: none;
			padding: 10px 20px;
			border-radius: 5px;
			cursor: pointer;
		}
		input[type="submit"]:hover {
			background-color: #3e8e41;
		}
		table {
			margin-top: 30px;
			border-collapse: collapse;
			width: 100%;
		}
		th, td {
			padding: 12px;
			text-align: left;
			border-bottom: 1px solid #ddd;
		}
		th {
			background-color: #4CAF50;
			color: #fff;
		}
	</style>
</head>
<body>
	<div class="container">
		<h1>Search Page</h1>
		<form id="search-form">
			<label for="search">Search:</label>
			<input type="text" id="search" name="search" placeholder="Search..." required>
			<label for="category">Search Type:</label>
			<select id="search-type" name="search-type" required>
				<option value="" disabled selected>Select a search type</option>
				<option value="tf-idf">TF-IDF</option>
				<option value="word-emading">Word Emading</option>
			</select>
			<label for="dataset">Dataset:</label>
			<select id="dataset" name="dataset" required>
				<option value="" disabled selected>Select a dataset</option>
				<option value="antique">Antique</option>
				<option value="car">Cars</option>
			</select>
			<input type="submit" value="Search">
		</form>
		<table id="results-table">
			<thead>
				<tr>
					<th>#ID</th>
					<th>DOC_ID</th>
					<th>TEXT</th>
					<th>SCORE</th>
				</tr>
			</thead>
			<tbody></tbody>
		</table>
	</div>
	<script>
		const searchForm = document.getElementById('search-form');
		const resultsTableBody = document.querySelector('#results-table tbody');

		searchForm.addEventListener('submit', async (event) => {
			event.preventDefault();
			const searchTerm = document.getElementById('search').value;
			const searchType = document.getElementById('search-type').value;
			const dataset = document.getElementById('dataset').value;
			const url = `http://localhost:8001/search/${searchTerm}/${searchType}/${dataset}`;
			try {
				const response = await fetch(url);
				if (!response.ok) {
					throw new Error('Network response was not ok');
				}
				const data = await response.json();
				displayResults(data);
			} catch (error) {
				console.error('There was a problem fetching the search results:', error);
			}
		});

		function displayResults(data) {
			resultsTableBody.innerHTML = '';
			if (data.length === 0) {
				resultsTableBody.innerHTML = '<tr><td colspan="4">No results found</td></tr>';
			} else {
				let i = 0;
				data.forEach(item => {
					i += 1;
					const row = document.createElement('tr');
					row.innerHTML = `
						<td>${i}</td>
						<td>${item[0]}</td>
						<td>${item[1]}</td>
						<td>${item[2]}</td>
					`;
				resultsTableBody.appendChild(row);
				});
			}
		}
	</script>
</body>
</html>